/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef LPERIODICAL_H
#define LPERIODICAL_H

typedef int EventRecord;

#if 0
class LPeriodical {
	MMRESULT mm;
	static void CALLBACK lpTimeProc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2) { ((LPeriodical*)dwUser)->SpendTime(42); }
public:
	LPeriodical() { mm = NULL; }
	~LPeriodical() { StopIdling(); }
	void StartIdling() { if (mm == NULL) mm == timeSetEvent(50, 25, (LPTIMECALLBACK) lpTimeProc, (DWORD) this, TIME_PERIODIC); }
	void StopIdling() { if (mm != NULL) { timeKillEvent(mm); mm = NULL; } }
	virtual void SpendTime(const EventRecord&) = 0;
};
#endif

#include "sched.h"
class LPeriodical {
	static ScheduleTime callback(void* v);
	task* t;
public:
	LPeriodical() { t = NULL; }
	~LPeriodical() { StopIdling(); }
	void StartIdling();
	void StopIdling();
	virtual void SpendTime(const EventRecord&) = 0;
};

#endif
// Author: Patrick Pelletier
